#!/bin/sh -
# $Id: cronjob.sh 1623 2008-04-05 21:49:25Z sra $
#
# Attempt to mirror mirin.apnic.net Wiki into Subversion, using w3m to
# generate flat text dumps of all those fun HTML files.

lock=cronjob.lock

cd `/usr/bin/dirname $0` || exit

case "$1" in

locked)

    exec >cronjob.log 2>&1

    set -x

    /bin/test -d html || /bin/mkdir html

    cd html

    reject="*action=edit*,*\?*,*.pdf,favicon.ico,Help:*,WikiMedia:*,User:*,User_talk:*,Special:Upload,Special:Specialpages,Special:Recentchanges,ResourceCertification:*,opensearch_desc.php"
    exclude_directories="/resourcecerts/wiki/pdf,/resourcecerts/wiki/skins"
    exclude_domains="www.mediawiki.org"

    /usr/local/bin/wget --mirror --no-verbose --no-parent --convert-links \
	--reject "$reject" --exclude-directories "$exclude_directories" --exclude-domains "$exclude_domains" \
	http://mirin.apnic.net/resourcecerts/wiki/index.php

    # Force retrivial of stuff indexed by pages that wget doesn't realize are HTML

    /usr/local/bin/wget --mirror --no-verbose --no-parent --convert-links \
	--reject "$reject" --exclude-directories "$exclude_directories" --exclude-domains "$exclude_domains" \
	--force-html --base http://mirin.apnic.net/resourcecerts/wiki/index.php \
	--input-file mirin.apnic.net/resourcecerts/wiki/index.php/Special:Categories

    # Brute force cleanup, as exclusions don't quite work

    /bin/rm -rf mirin.apnic.net/resourcecerts/wiki/pdf		\
		mirin.apnic.net/resourcecerts/wiki/skins	\
		www.mediawiki.org				\
		mirin.apnic.net/favicon.ico			\
		mirin.apnic.net/opensearch_desc.php

    cd ..

    /usr/bin/find html -name .svn -prune -o -type f -print0 |
    /usr/bin/xargs -0 file |
    /usr/bin/perl -e '
	while (<>) {
	    chomp;
	    next unless /HTML document text/;
	    s/:[ \t].+$//;
	    s/[""]/\\\"/g;
	    my $o = $_;
	    s{^html/}{text/};
	    my $n = $_;
	    s{/[^/]+$}{};
	    my $d = $_;
	    print("/usr/local/bin/w3m -dump -T text/html < \"$o\" > \"$n\"\n");
	    print("/bin/test -d \"$d\" || /bin/mkdir -p \"$d\"\n")
	        if (length($d) > 0);
	}
    ' |
    /usr/bin/sort -u |
    /bin/sh -x

    /usr/local/bin/svn update

    /usr/local/bin/svn add --force html text

    /usr/local/bin/svn st -v |
    /usr/bin/awk '$1 != "?" {print $NF}' |
    while read i
    do
      /bin/test -f "$i" &&
      /usr/local/bin/svn cat "$i" |
      /usr/bin/diff \
	-I '<!-- Served by [---A-Za-z0-9.]* in [0-9.]* secs. -->' \
	-I '<!-- Served by [---A-Za-z0-9.]* in [0-9.]* secs. --></body></html>' \
	>/dev/null - "$i" &&
      /usr/local/bin/svn revert -q "$i"
    done

    /usr/local/bin/svn ci --message 'Auto update'
    ;;

*)

    exec /usr/bin/lockf -s -t 0 $lock "$0" locked
    ;;

esac
